'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _react = require('react');

// Could use ES6 symbols in future

var _react2 = _interopRequireDefault(_react);

var CASE_SYMBOL = "__is-react-cond-component";

var isFunction = function isFunction(func) {
	return typeof func === 'function';
};
var isEqual = function isEqual(a, b) {
	return a === b;
};

var makeClause = function makeClause(compare) {
	return function (_ref3) {
		var _ref32 = _slicedToArray(_ref3, 2);

		var condition = _ref32[0];
		var result = _ref32[1];
		return isFunction(condition) ? [condition, result] : [function (x) {
			return compare(x, condition);
		}, result];
	};
};

var findFirst = function findFirst(arr, cond) {
	return arr.filter(function (_val, i) {
		return cond(arr[i]);
	})[0];
};

var Cond = _react2['default'].createClass({
	displayName: 'Cond',

	getDefaultProps: function getDefaultProps() {
		return {
			compare: isEqual
		};
	},

	componentWillReceiveProps: function componentWillReceiveProps(_ref4) {
		var nextValue = _ref4.value;
		var nextCompare = _ref4.compare;
		var _props = this.props;
		var compare = _props.compare;
		var value = _props.value;

		if (compare !== nextCompare || value !== nextValue) this.forceUpdate();
	},

	render: function render() {
		var _props2 = this.props;
		var children = _props2.children;
		var compare = _props2.compare;
		var value = _props2.value;

		var clauses = [];

		if (Array.isArray(children[0])) {
			clauses = children;
		} else if (children[0] && children[0].props && children[0].props[CASE_SYMBOL]) {
			// multiple clauses
			clauses = children.map(function (c) {
				return [c.props.test, c.props.children];
			});
		} else if (children && children.props && children.props[CASE_SYMBOL]) {
			// single clause
			clauses = [[children.props.test, children.props.children]];
		} else {
			clauses = [children];
		}

		var normalized = clauses.map(function (clause) {
			return Array.isArray(clause) ? makeClause(compare)(clause) : [T, clause];
		});

		var _findFirst = findFirst(normalized, function (_ref5) {
			var _ref52 = _slicedToArray(_ref5, 2);

			var condition = _ref52[0];
			var result = _ref52[1];
			return condition(value);
		});

		var _findFirst2 = _slicedToArray(_findFirst, 2);

		var condition = _findFirst2[0];
		var result = _findFirst2[1];

		return result;
	}
});

exports.Cond = Cond;
var T = function T() {
	return true;
};
exports.T = T;
var value = function value(name, condition) {
	return function (val) {
		return condition(val[name]);
	};
};

exports.value = value;
var Clause = _react2['default'].createClass({
	displayName: 'Clause',

	getDefaultProps: function getDefaultProps() {
		return _defineProperty({}, CASE_SYMBOL, true);
	},
	render: function render() {
		return null;
	}
});

exports.Clause = Clause;
var Default = _react2['default'].createClass({
	displayName: 'Default',

	getDefaultProps: function getDefaultProps() {
		return _defineProperty({
			test: T
		}, CASE_SYMBOL, true);
	},
	render: function render() {
		return null;
	}
});

exports.Default = Default;
var wrap = function wrap(fn) {
	var count = arguments.length <= 1 || arguments[1] === undefined ? 1 : arguments[1];
	return function () {
		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		if (args.length >= count + 1) {
			var _name = args[0];
			var params = args.slice(1);

			return value(_name, fn.apply(undefined, _toConsumableArray(params)));
		} else {
			return fn.apply(undefined, args);
		}
	};
};

var eq = wrap(function (x) {
	return function (y) {
		return x === y;
	};
});
exports.eq = eq;
var gt = wrap(function (x) {
	return function (y) {
		return y > x;
	};
});
exports.gt = gt;
var lt = wrap(function (x) {
	return function (y) {
		return y < x;
	};
});
exports.lt = lt;
var gte = wrap(function (x) {
	return function (y) {
		return y >= x;
	};
});
exports.gte = gte;
var lte = wrap(function (x) {
	return function (y) {
		return y <= x;
	};
});
exports.lte = lte;
var between = wrap(function (x, y) {
	return function (val) {
		return x < val && val < y;
	};
}, 2);
exports.between = between;
var isTrue = eq(true);
exports.isTrue = isTrue;
var isFalse = eq(false);
exports.isFalse = isFalse;
var isNull = eq(null);
exports.isNull = isNull;
var isUndefined = eq(undefined);

exports.isUndefined = isUndefined;
var and = function and(x, y) {
	return function (val) {
		return x(val) && y(val);
	};
};
exports.and = and;
var or = function or(x, y) {
	return function (val) {
		return x(val) || y(val);
	};
};
exports.or = or;
var not = function not(x) {
	return function (val) {
		return !x(val);
	};
};
exports.not = not;