'use strict';

exports.__esModule = true;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _utilSplitPath = require('./util/splitPath');

var _utilSplitPath2 = _interopRequireDefault(_utilSplitPath);

var _utilCurry = require('./util/curry');

var _utilCurry2 = _interopRequireDefault(_utilCurry);

function is(path, predicate, object) {
  var parts = _utilSplitPath2['default'](path);

  var rest = object;
  var part = undefined;
  for (var _iterator = parts, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
    if (_isArray) {
      if (_i >= _iterator.length) break;
      part = _iterator[_i++];
    } else {
      _i = _iterator.next();
      if (_i.done) break;
      part = _i.value;
    }

    if (typeof rest === 'undefined') return false;
    rest = rest[part];
  }

  if (typeof predicate === 'function') {
    return predicate(rest);
  }

  return predicate === rest;
}

exports['default'] = _utilCurry2['default'](is);
module.exports = exports['default'];